// ============================================================================
// $Id: lpc_protocol.hh,v 1.2 1996/04/26 23:33:04 questor Exp $
//
// This is part of Realm Of Magic
//
// Usage: Class that translates incoming messages into the lpc protocol
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Sushi)
// ============================================================================

#ifndef __INTERMUD__LPC_PROTOCOL_HH__
#define __INTERMUD__LPC_PROTOCOL_HH__

#include "protocol.hh"
#include "imuddefs.hh"

class _lpc : public _protocol {
private:
  list<lpc_info_record> packet_table;
  list<lpc_info_record> reply_table;

  lpc_info_record lpc_data;

  virtual string TypeName() { return "LPC       "; }
  virtual string BasedOn() {
    return "   |     - This MUD is a LPC based MUD      "
           "                      |\n";
  }
 
  void message2lpc(string &);
  void IncomingInterwiz();
  void IncomingReply(string &, sockaddr_in &);
  void IncomingIntertell(sockaddr_in &);
  void IncomingPing(sockaddr_in &);
  void IncomingWhoREQ();
  void HandleSplitPackets(string &, sockaddr_in &);
  
public:
  void Startup();
  void SendPings();
  bool IncomingMessage(string &, sockaddr_in &);
  bool OutgoingIntertell(string &, string &, string &, string &);
  bool OutgoingIntertellNR(string &, string &, string &, string &);
  bool OutgoingInterwho(string &, string &, string &);
  bool OutgoingInterwhoREQ(string &, string &);
  void OutgoingInterwiz(string &, string &);
  
};

#endif
