// ============================================================================
// $Id: mud.hh,v 1.2 1996/04/26 23:33:04 questor Exp $
//
// This is part of Realm Of Magic
//
// Usage: Class that cares for the intermud <-> mud communication
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Sushi)
// ============================================================================

#ifndef __INTERMUD__MUD_HH__
#define __INTERMUD__MUD_HH__

#include <sys/un.h>
#include "intermud.hh"

struct bullet {
  int bytes;
};

class _mud {
private:
  int file_descriptor;
  string out_data;
  string in_data;
  struct sockaddr_un adress;
  int adress_length;
  bool lost_connection;
  struct bullet bullet;

  int recv_data(char *);
  int send_data();
  
public:
  _mud();
  void AcceptConnection();
  bool MudLost();
  string ReceiveData();
  void FlushData();
  void AddToSet(fd_set &);
  bool CheckSet(fd_set &);
  void ClearSet(fd_set &);
  void CloseFD();
  string OutBuffer();
  int Desc();

  _mud& operator<<(string);
  _mud& operator<<(int);
  _mud& operator<<(unsigned int);
  _mud& operator<<(short int);
  _mud& operator<<(unsigned short int);
  _mud& operator<<(long int);
  _mud& operator<<(unsigned long int);
  _mud& operator<<(_mud& (*pf)(_mud&));

  friend _mud& sendit(_mud&);
  
};

_mud& sendit(_mud&);

#endif
